#include <stdio.h>
#include <errno.h>
#ifdef MPI
#include <mpi.h>
#endif
#include "DEFS.h"
#include "EU_OPT.h"


#ifdef MPI
int MyProcessorNumber, NumberofProcessors;
#endif

main(int argc, char *argv[])
{
  int err, Naccepted;
  char MC_description_file[MAX_FILE_NAME_LENGTH+1];
  char PROCESS_description_file[MAX_FILE_NAME_LENGTH+1];
  char UNDERLYING_description_file[MAX_FILE_NAME_LENGTH+1];
  char OPTION_description_file[MAX_FILE_NAME_LENGTH+1];
  char OPTION_Container[MAX_FILE_NAME_LENGTH+1];
  int status;

#ifdef MPI
  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &NumberofProcessors);
  MPI_Comm_rank(MPI_COMM_WORLD, &MyProcessorNumber);
#endif

#ifdef MPI
  if(MyProcessorNumber == MASTER){
#endif
    if(argc != 6) {
      fprintf(stderr,"European Option Pricing Demo::: Wrong number of parameters!\n");
      exit(1);
    } else {
      sscanf(argv[1],"%s",UNDERLYING_description_file);
      sscanf(argv[2],"%s",MC_description_file);
      sscanf(argv[3],"%s",PROCESS_description_file);
      sscanf(argv[4],"%s",OPTION_description_file);
      sscanf(argv[5],"%s",OPTION_Container);
    }
#ifdef MPI
  }
#endif

  if(( status   =  EuropeanOptionServer
                                       (
                                       UNDERLYING_description_file,
                                       MC_description_file,
                                       PROCESS_description_file,
                                       OPTION_description_file,
                                       OPTION_Container
                                       ) ) != DONE )  {
#ifdef MPI
              if(MyProcessorNumber == MASTER){
#endif
                     fprintf(stderr,"European Option Demo failed\n");
                     exit(1);
#ifdef MPI
              }
#endif

  }

#ifdef MPI
  MPI_Finalize();
#endif

} /* end of main() for European Option Demo */


